=== debian/changelog ===
pdf2djvu (0.9.18.2-2build6) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:09:22 +1100

pdf2djvu (0.9.18.2-2build5) noble; urgency=high

  * No change rebuild against libgraphicsmagick++-q16-12t64,
    libgraphicsmagick-q16-3t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 17:48:01 +0100

pdf2djvu (0.9.18.2-2build4) noble; urgency=medium

  * Rebuild against latest poppler

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 18 Feb 2024 18:11:43 -0500

pdf2djvu (0.9.18.2-2build3) noble; urgency=medium

  * Rebuild against latest poppler

 -- Jeremy Bícha <jbicha@ubuntu.com>  Mon, 04 Dec 2023 08:12:22 -0500

pdf2djvu (0.9.18.2-2build2) mantic; urgency=medium

  * Rebuild against latest poppler

 -- Jeremy Bícha <jbicha@ubuntu.com>  Thu, 17 Aug 2023 05:19:47 -0400

pdf2djvu (0.9.18.2-2build1) lunar; urgency=medium

  * Rebuild against latest poppler

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sun, 18 Dec 2022 08:43:00 -0500

pdf2djvu (0.9.18.2-2) unstable; urgency=medium

  * Fix build failure with Poppler 22.06 (Closes: #1012801)
  * deb/control:
    + bump standards to 4.6.1.0.

 -- Hsieh-Tseng Shen <woodrow.shen@gmail.com>  Fri, 12 Aug 2022 20:18:24 +0800

pdf2djvu (0.9.18.2-1) unstable; urgency=medium

  * New upstream release.
    + Document minimum required Exiv2 version.
    + Fix build failure with upcoming Exiv2 1.0.
    + Remove spurious zero-width spaces from the Ukrainian manual page.
  * Improve the test suite:
    + Fix test failure with Exiv2 ≥ 0.27.5.
      Thanks to Kamil Cukrowski for the bug report and the initial patch.
      https://github.com/jwilk/pdf2djvu/issues/149
  * deb/control:
    + bump standards to 4.6.0.2.

 -- Hsieh-Tseng Shen <woodrow.shen@gmail.com>  Fri, 18 Feb 2022 01:16:25 +0800

pdf2djvu (0.9.18.1-1) unstable; urgency=medium

  * New upstream release.
    + Fix build failure with Poppler ≥ 21.10.
    + Fix FTBFS with gcc-11. (Closes: #984288)

 -- Hsieh-Tseng Shen <woodrow.shen@gmail.com>  Thu, 28 Oct 2021 18:15:17 +0800
