=== debian/watch ===
version=4
opts="pgpsigurlmangle=s/$/.asc/" \
https://github.com/jwilk/pdf2djvu/releases (?:.*)pdf2djvu-(\d[\d\.]+)\.(?:tar\.gz|tar\.bz2|tar\.xz)
